#
3D-goodway.py    I. Marti-Vidal     IMPRS Blackboard Lectures 2011.
# SIMULATING AN ISOTROPIC UNIVERSE IN THE SMART WAY.

import numpy as np
import pylab as pl

# Parameters:
distmax = 100.  # Maximum distance (Mpc)
nmonte = 10000  # Number of galaxies.
bins=50         # Number of bins in histograms.

# Simulate:

RA = 24.*np.random.uniform(0.,1.,nmonte)  # Uniform distribution in RA.

# Distributions in Dec and Dist according to the inverse of their 
# cumulative functions :D :

Dec = 180./np.pi*np.arcsin(2.*(np.random.uniform(0.,1.,nmonte)-0.5))

Dist = distmax*np.power(np.random.uniform(0.,1.,nmonte),1./3.)

# Plot:
pl.figure()
pl.hist(RA,bins); pl.title("DISTRIBUTION IN RIGHT ASCENSION")
pl.xlabel("Right Ascension (hr)")
pl.figure()
pl.hist(Dec,bins); pl.title("DISTRIBUTION IN DECLINATION")
pl.xlabel("Declination (deg)")
pl.figure()
pl.hist(Dist,bins); pl.title("DISTRIBUTION OF DISTANCES")
pl.xlabel("Distance (Mpc)")
pl.figure()
pl.plot(RA,Dec,'.k'); pl.title("DISTRIBUTION ON THE SKY")
pl.xlabel("Right Ascension (hr)")
pl.ylabel("Declination (deg)")
pl.show()



