# 3D-wrongway.py    I. Marti-Vidal     IMPRS Blackboard Lectures 2011.
# SIMLATING AN ISOTROPIC UNIVERSE IN THE WRONG AND SILLY WAY.

import numpy as np
import pylab as pl

# Parameters:
distmax = 100.  # Maximum distance in simulation (Mpc, for instance)
nmonte = 10000  # Number of galaxies.
bins=50         # Number of bins in histogram plots.

# Distribute galaxies uniformly in Cartesian coordinates:
# (the observer would be at the coordinate origin).

X = np.random.uniform(-distmax,distmax,nmonte)
Y = np.random.uniform(-distmax,distmax,nmonte)
Z = np.random.uniform(-distmax,distmax,nmonte)

# Convert to celestial coordinates (i.e., from Cartesian to Spherical):

RA1 = np.arctan2(Y,X)*180./np.pi/15.
RA = (24.+RA1)*(RA1<0)+RA1*(RA1>0)    # Define RA between 0 and 24hr.

Dist1 = X*X+Y*Y
Dec = np.arctan2(Z,np.sqrt(Dist1))*180./np.pi
Dist = np.sqrt(Dist1+Z*Z)

# Plot galaxy distribution:
pl.figure(); pl.title("DISTRIBUTION IN RIGHT ASCENSION")
pl.hist(RA,bins)
pl.xlabel("Right Ascension (hr)")
pl.figure()
pl.hist(Dec,bins); pl.title("DISTRIBUTION IN DECLINATION")
pl.xlabel("Declination (deg)")
pl.figure()
pl.hist(Dist,bins); pl.title("DISTRIBUTION OF DISTANCES")
pl.xlabel("Distance (Mpc)")
pl.figure()
pl.plot(RA,Dec,'.k'); pl.title("DISTRIBUTION ON THE SKY")
pl.xlabel("Right Ascension (hr)")
pl.ylabel("Declination (deg)")
pl.show()

########################################################################

# Surprise, surprise!

########################################################################


hold = raw_input("\n Holding. Press ENTER to continue")

# Take only the galaxies inside the sphere of maximum distance:
Cuttoff = Dist < distmax  # This is a vector of Trues and Falses.

# RA[Cuttoff] only selects the elements with "Trues".

# Plot the set of remaining galaxies:
pl.figure()
pl.hist(RA[Cuttoff],bins); pl.title("DISTRIBUTION IN RIGHT ASCENSION")
pl.xlabel("Right Ascension (hr)")

pl.figure()
pl.hist(Dec[Cuttoff],bins); pl.title("DISTRIBUTION IN DECLINATION")
pl.xlabel("Declination (deg)")

pl.figure()
pl.hist(Dist[Cuttoff],bins); pl.title("DISTRIBUTION OF DISTANCES")
pl.xlabel("Distance (Mpc)")

pl.figure()
pl.plot(RA[Cuttoff],Dec[Cuttoff],'.k'); pl.title("DISTRIBUTION ON THE SKY")
pl.xlabel("Right Ascension (hr)")
pl.ylabel("Declination (deg)")

pl.show()


